// This file was generated by qtwaylandscanner
// source file is ../share-buffer.xml

#include "qwayland-server-share-buffer.h"

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")

namespace QtWaylandServer {
    qt_share_buffer::qt_share_buffer(struct ::wl_client *client, int id, int version)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
        init(client, id, version);
    }

    qt_share_buffer::qt_share_buffer(struct ::wl_display *display, int version)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
        init(display, version);
    }

    qt_share_buffer::qt_share_buffer(struct ::wl_resource *resource)
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
        init(resource);
    }

    qt_share_buffer::qt_share_buffer()
        : m_resource_map()
        , m_resource(nullptr)
        , m_global(nullptr)
    {
    }

    qt_share_buffer::~qt_share_buffer()
    {
        for (auto resource : qAsConst(m_resource_map))
            resource->share_buffer_object = nullptr;

        if (m_resource)
            m_resource->share_buffer_object = nullptr;

        if (m_global) {
            wl_global_destroy(m_global);
            wl_list_remove(&m_displayDestroyedListener.link);
        }
    }

    void qt_share_buffer::init(struct ::wl_client *client, int id, int version)
    {
        m_resource = bind(client, id, version);
    }

    void qt_share_buffer::init(struct ::wl_resource *resource)
    {
        m_resource = bind(resource);
    }

    qt_share_buffer::Resource *qt_share_buffer::add(struct ::wl_client *client, int version)
    {
        Resource *resource = bind(client, 0, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    qt_share_buffer::Resource *qt_share_buffer::add(struct ::wl_client *client, int id, int version)
    {
        Resource *resource = bind(client, id, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    void qt_share_buffer::init(struct ::wl_display *display, int version)
    {
        m_global = wl_global_create(display, &::qt_share_buffer_interface, version, this, bind_func);
        m_globalVersion = version;
        m_displayDestroyedListener.notify = qt_share_buffer::display_destroy_func;
        m_displayDestroyedListener.parent = this;
        wl_display_add_destroy_listener(display, &m_displayDestroyedListener);
    }

    const struct wl_interface *qt_share_buffer::interface()
    {
        return &::qt_share_buffer_interface;
    }

    qt_share_buffer::Resource *qt_share_buffer::share_buffer_allocate()
    {
        return new Resource;
    }

    void qt_share_buffer::share_buffer_bind_resource(Resource *)
    {
    }

    void qt_share_buffer::share_buffer_destroy_resource(Resource *)
    {
    }

    void qt_share_buffer::bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id)
    {
        qt_share_buffer *that = static_cast<qt_share_buffer *>(data);
        that->add(client, id, qMin(that->m_globalVersion, version));
    }

    void qt_share_buffer::display_destroy_func(struct ::wl_listener *listener, void *data)
    {
        Q_UNUSED(data);
        qt_share_buffer *that = static_cast<qt_share_buffer::DisplayDestroyedListener *>(listener)->parent;
        that->m_global = nullptr;
    }

    void qt_share_buffer::destroy_func(struct ::wl_resource *client_resource)
    {
        Resource *resource = Resource::fromResource(client_resource);
        Q_ASSERT(resource);
        qt_share_buffer *that = resource->share_buffer_object;
        if (Q_LIKELY(that)) {
            that->m_resource_map.remove(resource->client(), resource);
            that->share_buffer_destroy_resource(resource);

            that = resource->share_buffer_object;
            if (that && that->m_resource == resource)
                that->m_resource = nullptr;
        }
        delete resource;
    }

    qt_share_buffer::Resource *qt_share_buffer::bind(struct ::wl_client *client, uint32_t id, int version)
    {
        Q_ASSERT_X(!wl_client_get_object(client, id), "QWaylandObject bind", QStringLiteral("binding to object %1 more than once").arg(id).toLocal8Bit().constData());
        struct ::wl_resource *handle = wl_resource_create(client, &::qt_share_buffer_interface, version, id);
        return bind(handle);
    }

    qt_share_buffer::Resource *qt_share_buffer::bind(struct ::wl_resource *handle)
    {
        Resource *resource = share_buffer_allocate();
        resource->share_buffer_object = this;

        wl_resource_set_implementation(handle, nullptr, resource, destroy_func);
        resource->handle = handle;
        share_buffer_bind_resource(resource);
        return resource;
    }
    qt_share_buffer::Resource *qt_share_buffer::Resource::fromResource(struct ::wl_resource *resource)
    {
        if (Q_UNLIKELY(!resource))
            return nullptr;
        if (wl_resource_instance_of(resource, &::qt_share_buffer_interface, nullptr))
            return static_cast<Resource *>(wl_resource_get_user_data(resource));
        return nullptr;
    }

    void qt_share_buffer::send_cross_buffer(struct ::wl_resource *buffer)
    {
        Q_ASSERT_X(m_resource, "qt_share_buffer::cross_buffer", "Uninitialised resource");
        if (Q_UNLIKELY(!m_resource)) {
            qWarning("could not call qt_share_buffer::cross_buffer as it's not initialised");
            return;
        }
        send_cross_buffer(
            m_resource->handle,
            buffer);
    }

    void qt_share_buffer::send_cross_buffer(struct ::wl_resource *resource, struct ::wl_resource *buffer)
    {
        qt_share_buffer_send_cross_buffer(
            resource,
            buffer);
    }

}

QT_WARNING_POP
QT_END_NAMESPACE
