/* Generated by wayland-scanner 1.23.1 */

#ifndef QT_VULKAN_SERVER_BUFFER_UNSTABLE_V1_CLIENT_PROTOCOL_H
#define QT_VULKAN_SERVER_BUFFER_UNSTABLE_V1_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_qt_vulkan_server_buffer_unstable_v1 The qt_vulkan_server_buffer_unstable_v1 protocol
 * @section page_ifaces_qt_vulkan_server_buffer_unstable_v1 Interfaces
 * - @subpage page_iface_zqt_vulkan_server_buffer_v1 - Internal protocol for buffer sharing using Vulkan external memory
 * @section page_copyright_qt_vulkan_server_buffer_unstable_v1 Copyright
 * <pre>
 *
 * Copyright (C) 2019 The Qt Company Ltd.
 * Contact: http://www.qt.io/licensing/
 *
 * This file is part of the plugins of the Qt Toolkit.
 *
 * $QT_BEGIN_LICENSE:BSD$
 * You may use this file under the terms of the BSD license as follows:
 *
 * "Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * * Neither the name of The Qt Company Ltd nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
 *
 * $QT_END_LICENSE$
 * </pre>
 */
struct qt_server_buffer;
struct zqt_vulkan_server_buffer_v1;

#ifndef ZQT_VULKAN_SERVER_BUFFER_V1_INTERFACE
#define ZQT_VULKAN_SERVER_BUFFER_V1_INTERFACE
/**
 * @page page_iface_zqt_vulkan_server_buffer_v1 zqt_vulkan_server_buffer_v1
 * @section page_iface_zqt_vulkan_server_buffer_v1_desc Description
 *
 * This protocol is used internally by Qt for implementing the
 * qt_server_buffer extension on hardware that supports Vulkan external memory .
 *
 * This protocol is not part of the Qt API.  It exists purely as an
 * implementation detail and may change from version to
 * version without notice, or even be removed.
 * @section page_iface_zqt_vulkan_server_buffer_v1_api API
 * See @ref iface_zqt_vulkan_server_buffer_v1.
 */
/**
 * @defgroup iface_zqt_vulkan_server_buffer_v1 The zqt_vulkan_server_buffer_v1 interface
 *
 * This protocol is used internally by Qt for implementing the
 * qt_server_buffer extension on hardware that supports Vulkan external memory .
 *
 * This protocol is not part of the Qt API.  It exists purely as an
 * implementation detail and may change from version to
 * version without notice, or even be removed.
 */
extern const struct wl_interface zqt_vulkan_server_buffer_v1_interface;
#endif

/**
 * @ingroup iface_zqt_vulkan_server_buffer_v1
 * @struct zqt_vulkan_server_buffer_v1_listener
 */
struct zqt_vulkan_server_buffer_v1_listener {
	/**
	 * vulkan buffer information
	 *
	 * Informs the client about a newly created server buffer. The
	 * "fd" argument is a POSIX file descriptor representing the
	 * underlying resources of a Vulkan device memory object as defined
	 * in the GL_EXT_memory_object_fd extension.
	 * @param fd GL_EXT_memory_object_fd
	 * @param memory_size size in bytes
	 * @param format GL internal format
	 */
	void (*server_buffer_created)(void *data,
				      struct zqt_vulkan_server_buffer_v1 *zqt_vulkan_server_buffer_v1,
				      struct qt_server_buffer *id,
				      int32_t fd,
				      uint32_t width,
				      uint32_t height,
				      uint32_t memory_size,
				      uint32_t format);
};

/**
 * @ingroup iface_zqt_vulkan_server_buffer_v1
 */
static inline int
zqt_vulkan_server_buffer_v1_add_listener(struct zqt_vulkan_server_buffer_v1 *zqt_vulkan_server_buffer_v1,
					 const struct zqt_vulkan_server_buffer_v1_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zqt_vulkan_server_buffer_v1,
				     (void (**)(void)) listener, data);
}

/**
 * @ingroup iface_zqt_vulkan_server_buffer_v1
 */
#define ZQT_VULKAN_SERVER_BUFFER_V1_SERVER_BUFFER_CREATED_SINCE_VERSION 1


/** @ingroup iface_zqt_vulkan_server_buffer_v1 */
static inline void
zqt_vulkan_server_buffer_v1_set_user_data(struct zqt_vulkan_server_buffer_v1 *zqt_vulkan_server_buffer_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zqt_vulkan_server_buffer_v1, user_data);
}

/** @ingroup iface_zqt_vulkan_server_buffer_v1 */
static inline void *
zqt_vulkan_server_buffer_v1_get_user_data(struct zqt_vulkan_server_buffer_v1 *zqt_vulkan_server_buffer_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zqt_vulkan_server_buffer_v1);
}

static inline uint32_t
zqt_vulkan_server_buffer_v1_get_version(struct zqt_vulkan_server_buffer_v1 *zqt_vulkan_server_buffer_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zqt_vulkan_server_buffer_v1);
}

/** @ingroup iface_zqt_vulkan_server_buffer_v1 */
static inline void
zqt_vulkan_server_buffer_v1_destroy(struct zqt_vulkan_server_buffer_v1 *zqt_vulkan_server_buffer_v1)
{
	wl_proxy_destroy((struct wl_proxy *) zqt_vulkan_server_buffer_v1);
}

#ifdef  __cplusplus
}
#endif

#endif
