// This file was generated by qtwaylandscanner
// source file is ../../../../3rdparty/protocol/wl-eglstream-controller.xml

#ifndef QT_WAYLAND_SERVER_WL_EGLSTREAM_CONTROLLER
#define QT_WAYLAND_SERVER_WL_EGLSTREAM_CONTROLLER

#include "wayland-server-core.h"
#include "wayland-wl-eglstream-controller-server-protocol.h"
#include <QByteArray>
#include <QMultiMap>
#include <QString>

#ifndef WAYLAND_VERSION_CHECK
#define WAYLAND_VERSION_CHECK(major, minor, micro) \
    ((WAYLAND_VERSION_MAJOR > (major)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR > (minor)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR == (minor) && WAYLAND_VERSION_MICRO >= (micro)))
#endif

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")
QT_WARNING_DISABLE_CLANG("-Wmissing-field-initializers")

namespace QtWaylandServer {
    class  wl_eglstream_controller
    {
    public:
        wl_eglstream_controller(struct ::wl_client *client, int id, int version);
        wl_eglstream_controller(struct ::wl_display *display, int version);
        wl_eglstream_controller(struct ::wl_resource *resource);
        wl_eglstream_controller();

        virtual ~wl_eglstream_controller();

        class Resource
        {
        public:
            Resource() : eglstream_controller_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            wl_eglstream_controller *eglstream_controller_object;
            wl_eglstream_controller *object() { return eglstream_controller_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


    protected:
        virtual Resource *eglstream_controller_allocate();

        virtual void eglstream_controller_bind_resource(Resource *resource);
        virtual void eglstream_controller_destroy_resource(Resource *resource);

        virtual void eglstream_controller_attach_eglstream_consumer(Resource *resource, struct ::wl_resource *wl_surface, struct ::wl_resource *wl_resource);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::wl_eglstream_controller_interface m_wl_eglstream_controller_interface;

        static void handle_attach_eglstream_consumer(
            ::wl_client *client,
            struct wl_resource *resource,
            struct ::wl_resource *wl_surface,
            struct ::wl_resource *wl_resource);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        uint32_t m_globalVersion;
        struct DisplayDestroyedListener : ::wl_listener {
            wl_eglstream_controller *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };
}

QT_WARNING_POP
QT_END_NAMESPACE

#endif
